/*================================================
SAS[U[2015
\vOA

_PG9 - PG10

201505
oT[`Ё@XT

===============================================*/

proc format;
value syouhin
	1='ނ'
	2=''
	3='S'
	4='r['
	5='p'
;
run;
quit;

/*eXgf[^3*/
data DATA3;
ID=1;ITEM=put(1,syouhin.);output;
ID=1;ITEM=put(2,syouhin.);output;
ID=1;ITEM=put(3,syouhin.);output;
ID=1;ITEM=put(4,syouhin.);output;
ID=2;ITEM=put(3,syouhin.);output;
ID=2;ITEM=put(4,syouhin.);output;
ID=3;ITEM=put(1,syouhin.);output;
ID=3;ITEM=put(4,syouhin.);output;
ID=4;ITEM=put(1,syouhin.);output;
ID=4;ITEM=put(2,syouhin.);output;
ID=4;ITEM=put(4,syouhin.);output;
ID=5;ITEM=put(1,syouhin.);output;
ID=5;ITEM=put(4,syouhin.);output;
ID=5;ITEM=put(5,syouhin.);output;
run;


/*PG9 21̃ACeZbgƂJEg*/
data _NULL_;
    informat ID ITEM ITEM2 COUNT2;

    if _N_=1 then
        do;
            declare hash h2 (suminc:'COUNT2', hashexp:2);
            h2.defineKey ('ITEM', 'ITEM2');
            h2.definedata('ITEM', 'ITEM2', 'COUNT2');
            h2.defineDone ();
        end;

    do while(^FL);
        set DATA3 end=FL;

        do i=1 to tobs;
            set DATA3(rename=(ID=_ID ITEM=ITEM2)) point=i nobs=tobs;

            if ID=_ID and ITEM < ITEM2 then
                do;
			        COUNT2=1;
                    h2.ref();
                    h2.sum (sum: COUNT2);
                    h2.replace();
					output;
                end;
        end;

        if FL then
            do;
                h2.output(dataset:'OUT7');
            end;
    end;
    stop;
run;



/*==================================================================
ȉAPG10@A\VG[V
====================================================================*/

/*ڋq}NϐɊi[*/
proc sql noprint;
	select count(distinct id) into : sobs
	from DATA3;
quit;

/*͏*/
data OUT8;
 informat VECTOR ITEM ITEM2 ITEM3 COUNT1 COUNT2 COUNT3 COUNT SUPPORT CONFIDENCE LIFT;

 if _N_=1 then  do;
	/*3ACe1Zbgł̃JEgpnbVIuWFNg(h3)ƃnbVqIuWFNg(hi3)*/
 	declare hash h3 (suminc:'COUNT3');
 	declare hiter hi3 ('h3');
	h3.defineKey ('ITEM', 'ITEM2','ITEM3');
   	h3.definedata('ITEM', 'ITEM2','ITEM3','COUNT3');
   	h3.defineDone ();

	/*2ACe1Zbgł̃JEgpnbVIuWFNg(h2)ƃnbVqIuWFNg(hi2)*/
  	declare hash h2 (suminc:'COUNT2');
  	declare hiter hi2 ('h2');
   	h2.defineKey ('ITEM','ITEM2');
   	h2.definedata('ITEM','ITEM2', 'COUNT2');
   	h2.defineDone ();

	/*1ACeł̃JEgpnbVIuWFNg(h1)ƃnbVqIuWFNg(hi1)*/
  	declare hash h1 (suminc:'COUNT1');
  	declare hiter hi1 ('h1');
   	h1.defineKey ('ITEM');
   	h1.definedata('ITEM','COUNT1');
   	h1.defineDone ();
 end;

 do while(^FL);
	set DATA3 end = FL;
  	COUNT1 = 1;
  	h1.ref();/*1ACeł̃JEg*/

	 do i=1 to tobs;
	  set DATA3( rename = (ID = _ID ITEM = ITEM2) ) point = i nobs = tobs ;
	   if ID = _ID and ITEM ne ITEM2 then do;  /*Ԃւ̂܂߂()*/
	      COUNT2 = 1;
	      h2.ref();  /*2ACeł̃JEg*/
	       do j=1 to tobs;
		   /*2ACe1ACȇgݍ킹*/
	        set DATA3(rename = ( ID = _ID ITEM = ITEM3)) point=j nobs=tobs;
			  /*2ACȅԂ͖̂ŕsgp*/
	          if ID=_ID and ITEM < ITEM2 and ITEM ne ITEM3 and ITEM2 ne ITEM3 then do;
	             COUNT3=1;
	             h3.ref();
	           end;
	       end;
	    end;
	  end;

 /*---------------------------------------------------------------------------
 
 FLDATA3end=Ȃ̂ŁAȉ̃[vn܂鎞_őSẴJEg͏IĂ
 Ƃ̓nbVqIuWFNgŏŌ܂œǂݍމߒŁAvZ
 vZʂoutputĂ
 ----------------------------------------------------------------------------*/
 if FL then do; 
  retain COUNT3;
  /*3ACěvZ*/
   do rc = hi3.first() by 0 while (rc = 0); /*nbVqIuWFNgԂɑSēǂݍ*/
      LEVEL  = 3 ;
      VECTOR = cats( ITEM , '&' , ITEM2 , '' ,ITEM3 );
      h3.sum(sum : COUNT3);
      SUPPORT = COUNT3 / &sobs;       /*xx*/
      h2.sum(sum : COUNT2);
	  h1.sum(key : ITEM3 , sum : COUNT1);
      CONFIDENCE = COUNT3 / COUNT2;   /*Mx*/
	  _SUPPORT   = COUNT1 / &sobs;    /*Α(ITEM3)̎xx*/
      LIFT = CONFIDENCE / _SUPPORT;   /*tg*/
	  COUNT = COUNT3;
     output;
	 /*ŌvZ̕ЂԂ*/
      VECTOR = cats( ITEM3 , '' , ITEM , '&' ,ITEM2 );
      CONFIDENCE = COUNT3 / COUNT1;   /*Mx*/
	  _SUPPORT   = COUNT2 / &sobs;    /*Α(ITEM&ITEM2)̎xx*/
      LIFT = CONFIDENCE / _SUPPORT;   /*tg*/
     output;
      rc = hi3.next();	/*nbVqIuWFNg̎̃R[h擾*/
    end;

  /*2ACěvZ*/
   do rc = hi2.first() by 0 while (rc = 0);
      LEVEL = 2 ;
      VECTOR = cats( ITEM , '' , ITEM2 );
      h2.sum(sum : COUNT2);
      SUPPORT = COUNT2 / &sobs;       /*xx*/
      h1.sum(sum : COUNT1);
      CONFIDENCE = COUNT2 / COUNT1;   /*Mx*/
	  h1.sum(key : ITEM2 , sum : _COUNT1);
      _SUPPORT = _COUNT1 / &sobs;     /*Α(ITEM2)̎xx*/
      LIFT = CONFIDENCE/_SUPPORT;     /*tg*/
	  COUNT = COUNT2;
     output;
      rc=hi2.next();
   end;

  /*1ACěvZ*/
   do rc=hi1.first() by 0 while (rc = 0);
      LEVEL = 1 ;
      VECTOR = cats( ITEM );
      h1.sum(sum: COUNT1);
      SUPPORT = COUNT1 / &sobs;          /*xx*/
	  COUNT = COUNT1;
      call missing( CONFIDENCE , LIFT);
     output;
      rc=hi1.next();
    end;
   end;
 end;

stop;
keep VECTOR SUPPORT COUNT CONFIDENCE LIFT;
run;

options missing='-';

proc sort data=OUT8 out=OUTPUT;
 by descending COUNT;
run;

